' @copyright(disclaimer) 
' Licensed Materials - Property of IBM
' IBM  Enterprise Information Portal for Multiplatforms V8.1  (program number 5724-B43)
' (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.
' 
' US Government Users Restricted Rights
' Use, duplication or disclosure restricted by GSA ADP Schedule
' Contract with IBM Corp.
' 
' DISCLAIMER OF WARRANTIES :
' 
' Permission is granted to copy and modify this Sample code, and to
' distribute modified versions provided that both the copyright
' notice,- and this permission notice and warranty disclaimer appear in all copies and 
' modified versions. 
' 
' THIS SAMPLE CODE IS LICENSED TO YOU AS-IS. 
' IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR IMPLIED, 
' IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE IMPLIED 
' WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO EVENT WILL 
' IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT OF THE USE OF OR 
' INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE, OR COMBINATION OF THE 
' SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS LICENSORS AND 
' SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR FOR DIRECT, INDIRECT, 
' SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND REGARDLESS OF 
' THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS LICENSORS OR SUPPLIERS HAVE BEEN ADVISED 
' OF THE POSSIBILITY OF SUCH DAMAGES.
'
' @endCopyright

VERSION 5.00
Begin VB.Form TxdoIndexDL 
   Caption         =   "TxdoIndexDL"
   ClientHeight    =   9150
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5805
   LinkTopic       =   "TxdoIndexDL"
   ScaleHeight     =   9150
   ScaleWidth      =   5805
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Run 
      Caption         =   "Run"
      Height          =   495
      Left            =   2160
      TabIndex        =   3
      Top             =   8160
      Width           =   1215
   End
   Begin VB.CommandButton Disconnect 
      Caption         =   "Disconnect"
      Height          =   495
      Left            =   4080
      TabIndex        =   2
      Top             =   8160
      Width           =   1215
   End
   Begin VB.CommandButton Connect 
      Caption         =   "Connect"
      Height          =   495
      Left            =   240
      TabIndex        =   1
      Top             =   8160
      Width           =   1455
   End
   Begin VB.TextBox Results 
      Height          =   7335
      Left            =   120
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   0
      Top             =   240
      Width           =   5175
   End
End
Attribute VB_Name = "TxdoIndexDL"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Dim hInst As Integer
Dim dsDL As DXDatastoreDL
Dim xdo  As DXBlobDL
Dim itemId As String
Dim partId As Long

Private Sub cout(str As String)
    Results.Text = Results.Text & Chr$(13) & Chr$(10) & str
End Sub

Private Sub Connect_Click()
    'following itemId & partId should be already exist
    'modify it with your own known itemId & partId
    itemId = "DXGJJXJOA789ESOE"
    partId = 2
    Set dsDL = New DXDatastoreDL
    Set xdo = New DXBlobDL
    xdo.init dsDL
    xdo.setPartId partId
    xdo.setItemId itemId
    
    cout "The following itemId and partId will be used:"
    cout "(Please change the itemId to an existing one of your system, "
    cout " and change the partId to the one you pick) "
    cout " "
    cout "  itemId = " & itemId
    cout "  partId = " & partId
    cout " "
    cout "Connecting to datastore of LIBSRVRP in DL ...."
    dsDL.Connect "LIBSRVRP", "FRNADMIN", "PASSWORD", ""
    On Error GoTo Errors
    cout "===Datastore connected==="
    Disconnect.Enabled = True
    Connect.Enabled = False
    Run.Enabled = True
    
    Exit Sub
Errors:
    cout "Errors:" & str(Err.Number) & Err.Description
    
End Sub

Private Sub Disconnect_Click()
  cout "disconnect from DL server"
  dsDL.Disconnect
  On Error GoTo Errors
  cout "===datastore disconnected==="
  Connect.Enabled = True
  Disconnect.Enabled = False
  Run.Enabled = False
  Exit Sub

Errors:
    cout "Errors:" & str(Err.Number) & Err.Description
End Sub

Private Sub Run_Click()

    Results.Text = ""
    cout "  itemId = " & itemId
    cout "  partId = " & partId
    cout " "
    cout "about to retrieve() and open()"
    xdo.retrieve
    On Error GoTo Errors
    cout "retrieve() successfully....."
    If xdo.getContentClass() = DX_DL_CC_ASCII Then
       xdo.setInstanceOpenHandler "notepad ", True
       xdo.open
       cout "open() successfully...."
    End If
    cout "getSize=" & xdo.getSize
    cout "updatedTimestamp=" & xdo.getUpdatedTimestamp
    cout "mimeType=" & xdo.getMimeType
    
    'following just for code example of set/getOption
    cout "following just for information and code example:"
    Dim delOpt As Variant
    Dim retrieveOpt As Variant
    cout "about to getOption of DELETE"
    xdo.getOption DX_DL_OPT_DELETE_OPTION, delOpt
    cout "about to getOption of RETRIEVAL"
    xdo.getOption DX_DL_OPT_DL_RETRIEVAL_ACTION, retrieveOpt
    cout "  default deleteOption=" & delOpt
    cout "  default retrieveOpt=" & retrieveOpt
    xdo.setOption DX_DL_OPT_DELETE_OPTION, DX_DL_DELETE_DROPITEM_MEDIA_INUSE
    xdo.getOption DX_DL_OPT_DELETE_OPTION, delOpt
    cout "  setted deleteOption=" & delOpt
    
    cout "Check if was indexed, if not then do indexing:"
    Dim catflag As Boolean
    catflag = xdo.isCategoryOf(DX_DL_INDEXED_OBJECT)
    cout "isCategoryOf indexed obj = " & catflag
    If (catflag) Then
      cout "==alreay indexed, do getExtension to show informations:"
      Dim srcheng2 As Variant
      Set srcheng2 = xdo.getExtension("DXSearchEngineInfoDL")
      On Error GoTo Errors
      cout " srcheng2.getSearchEngine=" & srcheng2.getSearchEngine
      cout " srcheng2.getSearchIndex=" & srcheng2.getSearchIndex
      cout " srcheng2.getSearchInfo=" & srcheng2.getSearchInfo
      cout " srcheng2.getTextIndex=" & srcheng2.getTextIndex
      cout " srcheng2.getCatalog=" & srcheng2.getCatalog
      cout " srcheng2.getDataBase=" & srcheng2.getDataBase
      cout " srcheng2.getServerName=" & srcheng2.getServerName
      cout " srcheng2.getSearchClassId=" & srcheng2.getSearchClassId
      cout " srcheng2.getSearchTimestamp=" & srcheng2.getSearchTimestamp
      cout " xdo.retrieveObjectState=" & xdo.retrieveObjectState(DX_DL_INDEXED_OBJECT)
    Else
      cout "==not indexed, do new DXSearchEngingInfoDL to prepare:"
      Dim srcheng As New DXSearchEngineInfoDL
      srcheng.setSearchEngine "SM"
      srcheng.setSearchInfo "ENU"
      'srcheng.setSearchIndex "TMMUF-TMINDEX"
      srcheng.setSearchIndex "TM-TMINDEX"
      cout " set srcheng extension obj..."
      xdo.setExtension srcheng
      On Error GoTo Errors
      cout " about to setToBeIndexed..."
      xdo.setToBeIndexed
      On Error GoTo Errors
      cout " setToBeIndexed success..."

    End If
    cout "isCategoryOf media obj=" & xdo.isCategoryOf(DX_DL_MEDIA_OBJECT)
    cout "isCategoryOf indexed obj=" & xdo.isCategoryOf(DX_DL_INDEXED_OBJECT)
    
        
    Exit Sub
Errors:
    cout "Errors:" & str(Err.Number) & Err.Description
    
End Sub
