/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Enterprise Information Portal for Multiplatforms V8.1 (program number 5724-B43)*
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                         *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************/
                         
//*****************************************************************************
//
// Filename : TLISTITEMSWFS.CPP/MAK
// Description : List items in WorkFlow/WorkBasket
//
// Required setup:  
//          
//    - Item ID of a WorkFlow (e.g., "HI7MOPALUPFQ1U47") 
//*****************************************************************************

#include <iostream.h>
#include <stdio.h>                
#include <DKConstant.h>
#include <DKDatastoreDL.hpp>
#include <DKWorkFlowServiceDL.hpp>
#include <DKException.hpp> 
#include <DKString.hpp>
#include <DKDDO.hpp>
#include <DKSequentialCollection.hpp>
#include <DKEnvironment.hpp>

void main(int argc, char *argv[])
{
    //replace following with your library server name, userid, pasword
    DKString STR_LIB_SERVER = "LIBSRVRN";
    DKString STR_USER_ID    = "FRNADMIN";
    DKString STR_PASSWORD   = "PASSWORD";

    cout << "begin..." << endl;
    DKDatastoreDL dsDL; // must be outside try/catch block

    try {
    // Indicate this is a Console Application on Windows NT/95 for error
    // message code page conversion to OEM code page. If this was a Windows
    // GUI (Graphic User Interface) Application this would not be necessary
    // because DK_SS_WINDOWS is the default.
    DKEnvironment::setSubSystem(DK_SS_CONSOLE);

    DKString str; 
    DKAny input_option = DK_SS_CONFIG;
    DKAny output_option;
    DKWorkFlowServiceDL wfDL(&dsDL);
    int i = 0;

    DKString itemIDWF = DKString("HI7MOPALUPFQ1U47");
    cout << "Datastore DL created" << endl;
    cout << "connecting to datastore" << endl;
    dsDL.connect(STR_LIB_SERVER, STR_USER_ID, STR_PASSWORD);
    cout << "datastore connected" << endl;

    if (wfDL.isConnected())
	cout << "workflow service has been connected" << endl;
    else
	cout << "workflow service is not connected" << endl;	
	
    DKWorkFlowDL * wf = new DKWorkFlowDL(&wfDL, (char *)itemIDWF);
    wf->retrieve();
    cout << "WF ID is " << wf->getID() << endl;
    cout << "Workflow Name is " << wf->getName() << endl;

    DKSequentialCollection * pColDoc1 = (DKSequentialCollection *)wf->listItemIDs();

    if (pColDoc1 != NULL) 
      {
        dkIterator* pIterDoc1 = pColDoc1->createIterator(); 
        DKString DocID1;
        DKAny a;
        cout << "There are " << pColDoc1->cardinality() 
	     << " folder(s)/document(s) defined in the workflow." << endl;
        while(pIterDoc1->more() == TRUE)
          {	
            a = (*pIterDoc1->next());
            DocID1 = a.toString();
	    cout << "Item ID = " << DocID1 << endl;				    
          }	
      }	

    DKAny a;
    DKString strData;
    DKString strDataName;
    DKWorkManagementInfoDL* item = 0;
    DKSequentialCollection * pColDoc2 = (DKSequentialCollection *)wf->listWorkManagementInfos();

    if (pColDoc2 != NULL) 
      {
        dkIterator* pIterDoc2 = pColDoc2->createIterator(); 
	cout << "There are " << pColDoc2->cardinality() 
	     << " folder(s)/document(s) defined in the workflow." << endl;
        while (pIterDoc2->more())
          {
	    a = *(pIterDoc2->next());
	    item = (DKWorkManagementInfoDL*)((void *)a);
	 
            if (item != 0) 
              {		  		 
	        cout << "Item ID " << item->getItemID() << endl;         
                cout << "Suspension Status " << item->getSuspensionStatus() << endl;
	        cout << "WorkFlow Status " << item->getWorkFlowStatus() << endl;
	        cout << "Release Type " << item->getReleaseType() << endl;
	        cout << "Priority " << item->getPriority() << endl;
	        cout << "WorkFlow ID " << item->getWorkFlowID() << endl;
	        cout << "WorkBasket ID " << item->getWorkBasketID() << endl;
          
	        DKTimestamp tsVal = item->getWFEntry();
	        cout << "WFEntry " 
	             << "     Year: "    << tsVal.getYear() 
                     << "     Month: "   << tsVal.getMonth() 
                     << "     Day: "     << tsVal.getDay()      
                     << "     Hours: "   << tsVal.getHours()   
                     << "     Minutes: " << tsVal.getMinutes() 
                     << "     Seconds: " << tsVal.getSeconds() 
                     << "     Nanos: "   << tsVal.getNanos() 
                     << endl;
     
                tsVal = item->getWBEntry();
	        cout << "WBEntry " 
	             << "     Year: "    << tsVal.getYear() 
                     << "     Month: "   << tsVal.getMonth() 
                     << "     Day: "     << tsVal.getDay()      
                     << "     Hours: "   << tsVal.getHours()   
                     << "     Minutes: " << tsVal.getMinutes() 
                     << "     Seconds: " << tsVal.getSeconds() 
                     << "     Nanos: "   << tsVal.getNanos() 
                     << endl;
                                
		delete item;
              }
          }  
      }

    dsDL.disconnect();
    cout << "datastore disconnected" << endl;
    }
 
    catch(DKException &exc)
    {
      cout << "Error id "     << exc.errorId() << endl;
      cout << "Exception id " << exc.exceptionId() << endl;
      for(unsigned long i = 0; i< exc.textCount();i++)
      {
       cout << "Error text: " << exc.text(i) << endl;
      }
      for (unsigned long g=0; g< exc.locationCount();g++)
      {
       const DKExceptionLocation* p = exc.locationAtIndex(g);
       cout << "Filename: " << p->fileName() << endl;
       cout << "Function: " << p->functionName() << endl;
       cout << "LineNumber: " << p->lineNumber() << endl;
      }
      cout << "Exception Class Name: " << exc.name() << endl;
    }

    cout << "done ..." << endl;
    
}
