/************************************************************************/
/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Enterprise Information Portal for Multiplatforms V8.1 (program number 5724-B43)*
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                         *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************/
/************************************************************************/

/*
 * Filename       : TListCatalogV4.cpp
 * Description    : List V4 catalog information
 *
 */

#include <iostream.h>
#include <stdio.h>                
#include <DKConstant.h>
#include <DKDatastoreV4.hpp>
#include <DKDatastoreDefV4.hpp>
#include <DKException.hpp>
#include <DKString.hpp>
#include <DKSequentialCollection.hpp>
#include <DKAttrDefV4.hpp>
#include <DKServerDefV4.hpp>
#include <DKIndexClassDefV4.hpp>
#include <DKEnvironment.hpp>

void main(int argc, char *argv[])
{
   cout << "begin..." << endl;

   // Indicate this is a Console Application on Windows NT/95 for error
   // message code page conversion to OEM code page. If this was a Windows
   // GUI (Graphic User Interface) Application this would not be necessary
   // because DK_SS_WINDOWS is the default.
   DKEnvironment::setSubSystem(DK_SS_CONSOLE);

    //-------------------------------------------------------------- 
    // Checking for input parameters
    //--------------------------------------------------------------   
    if (argc < 4)
    {
     cout<<"Usage: "<<endl;
     cout<<"  TListCatalogV4 <libsrv> <userid> <pw>" << endl;
     return;
    }
    // ### get input parameters
    DKString libsrv = DKString(argv[1]);
    DKString userid = DKString(argv[2]);
    DKString pw = DKString(argv[3]);
    DKDatastoreV4 dsV4; // must be outside try/catch block

   try {
      
      DKSequentialCollection *pCol = 0;
      dkIterator *pIter = 0;
      DKSequentialCollection *pCol2 = 0;
      dkIterator *pIter2 = 0;
      DKServerDefV4 *pSV = 0;
      DKIndexClassDefV4 *pEnt = 0;
      DKString strServerName;
      DKString strServerType;
      DKString strIndexClass;
      DKAttrDefV4 *pAttr = 0;
      DKAny a;
      DKAny *pA = 0;
      long i = 0;
      long j = 0;
      cout << "list servers" << endl;
      a = dsV4.listDataSources();
      pCol = (DKSequentialCollection*)((dkCollection*)a);
      pIter = pCol->createIterator();
      while (pIter->more() == TRUE)
      {
       i++;
       pSV = (DKServerDefV4*)((void*)(*pIter->next()));
       strServerName = pSV->getName();
       strServerType = pSV->getServerType();
       cout << "Server Name [" << i << "] - " << strServerName << " Server Type - " << strServerType << endl; 
       delete pSV;
      }
      delete pIter;
      delete pCol;
      cout << i << " servers listed" << endl;
      cout << "connecting to datastore" << endl;
      dsV4.connect(libsrv,userid,pw);
      cout << "datastore connected " << libsrv << " userid - " << userid << endl;
      cout << "list index classes" << endl;
      pCol = (DKSequentialCollection*)((dkCollection*)dsV4.listEntities());
      pIter = pCol->createIterator();
      i = 0;
      while (pIter->more() == TRUE)
      {
       i++;
       pEnt = (DKIndexClassDefV4*)((void*)(*pIter->next()));
       strIndexClass = pEnt->getName();
       cout << "index class name [" << i << "] - " << strIndexClass << endl;
       cout << "  list attributes for " << strIndexClass << " index class" << endl;
       pCol2 = (DKSequentialCollection*)((dkCollection*)dsV4.listEntityAttrs(strIndexClass));
       pIter2 = pCol2->createIterator();
       j = 0;
       while (pIter2->more() == TRUE)
       {
        j++;
        pA = pIter2->next();
        pAttr = (DKAttrDefV4*) pA->value();
        cout << "    Attribute name [" << j << "] - " << pAttr->getName() << endl;
        cout << "      datastoreName " << pAttr->datastoreName() << endl;
        cout << "      datastoreType " << pAttr->datastoreType() << endl;
        cout << "      attributeOf   " << pAttr->getEntityName() << endl;
        cout << "      type          " << pAttr->getType() << endl;
        cout << "      size          " << pAttr->getSize() << endl;
        cout << "      id            " << pAttr->getId() << endl;
        cout << "      nullable      " << pAttr->isNullable() << endl;
        cout << "      precision     " << pAttr->getPrecision() << endl;
        cout << "      scale         " << pAttr->getScale() << endl;
        cout << "      string type   " << pAttr->getStringType() << endl;
        delete pAttr;
       }
       cout << "  " << j << " attributes listed for " << strIndexClass << " index class" << endl;
       delete pIter2;
       delete pCol2;
       delete pEnt;
      }
      delete pIter;
      delete pCol;
      cout << i << " index classes listed" << endl;
      dsV4.disconnect();
      cout << "datastore disconnected" << endl;
   }
   catch(DKException &exc)
   {
      cout << "Error id " << exc.errorId() << endl;
      for(unsigned long i = 0; i< exc.textCount();i++)
      {
         cout << "Error text: " << exc.text(i) << endl;
      }
      for (unsigned long g=0; g< exc.locationCount();g++)
      {
         const DKExceptionLocation* p = exc.locationAtIndex(g);
         cout << "Filename: " << p->fileName() << endl;
         cout << "Function: " << p->functionName() << endl;
         cout << "LineNumber: " << p->lineNumber() << endl;
      }

      cout << "Exception Class Name: " << exc.name() << endl;
   }
   
   cout << "done ..." << endl;
   
}
