//
/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Enterprise Information Portal for Multiplatforms V8.1 (program number 5724-B43)*
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                         *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************/
//


// sample connect/disconnect to DES

/*
 * Filename       : TStoreSaveQueryDES.java
 * Description    : Connect to DES datastore
 *                  Create a query
 *                  Add the query to a preexisting folder to be scheduled 
 *                  disconnect from datastore
 *
 */

import com.ibm.mm.sdk.common.*;
import com.ibm.mm.sdk.server.*;
import com.ibm.bts.es.srv.sQry.*;
import java.io.*;
import java.util.*;

// TStoreSaveQueryDES class
public class TStoreSaveQueryDES implements DKConstantDES {

  // Main method
  public static void main(String argv[]){

   // Indicate this is a Console Application on Windows NT/95 for error
   // message display in dos console code page. If this was a Windows
   // GUI (Graphic User Interface) Application this would not be necessary
   // because DK_CM_SS_WINDOWS is the default.
   DKEnvironment.setSubSystem(DK_CM_SS_CONSOLE);

      //--------------------------------------------------------------
      // Checking for input parameters
      //--------------------------------------------------------------
      if (argv.length != 4)
      {
       System.out.println("Usage: " );
       System.out.println("java TStoreSaveQueryDES " +
        "tcp/ipAddress " +
        "userid " +
        "userpw " +
        "PORT=80;DESAPPID=appid;DESAPPPW=apppw[;DESCFGPATH=<des cfg file>;DESLOCALE=<locale>]");
       return;
      }

   System.out.println("TStoreSaveQueryDES");
   System.out.println("");
    DKDatastoreDES dsDES = null;
    try {
    dsDES = new DKDatastoreDES();
    String userName = dsDES.userName();
    String dsName = dsDES.datastoreName();
    System.out.println("user " + userName + " dsName " + dsName);
    System.out.println("connecting to datastore");
    dsDES.connect(argv[0], argv[1], argv[2], argv[3]);
    System.out.println("datastore connected " + argv[0] + " userid - " + argv[1]);
    userName = dsDES.userName();
    dsName = dsDES.datastoreName();
    System.out.println("user " + userName + " dsName " + dsName);

    String cmd = "SEARCH=(DATABASE=(File System Sources);COND=(Notes);";
    cmd = cmd + "OPTION=(MAX_RESULTS=5;TIME_LIMIT=10;SOURCE_MAX_RESULTS=5;MAX_RESULTS_PER_PAGE=5;FIND_ALL_WORDS=NO;PAGE_SCROLL=1;SORT=(Subject,DESC);RESULTS_WHEN_AVAILABLE=YES;);CONSTRAINTS=((DocFileName,EQ,despms56.htm);))";
    System.out.println("cmd=" + cmd);   

        DKNVPair options[] = new DKNVPair[33];
	
	//schedule query options
        options[0] = new DKNVPair("desStoredQueryName","Test1"); 
	options[1] = new DKNVPair("DOCDATEOP","EQ");    
	options[2] = new DKNVPair("DESResultsFmt","HTML");  
	options[3] = new DKNVPair("desStoredQueryStartDay","Thursday");
	options[4] = new DKNVPair("desStoredQueryFreq","1");     
	options[5] = new DKNVPair("desStoredQueryStoreHitlistFlag","Yes");   
	options[6] = new DKNVPair("esExpandHits","No");    
	options[7] = new DKNVPair("desStoredQuerySavePrevResultsFlag","YES");    
	options[8] = new DKNVPair("DOCAUTH","");
	options[9] = new DKNVPair("esExpandSrcs","N"); 
	options[10] = new DKNVPair("desStoredQueryFolderName","ExtraParms"); 
	options[11] = new DKNVPair("esQuerySaved","No");        
	options[12] = new DKNVPair("desStoredQueryDesc","Test");      
        options[13] = new DKNVPair("desStoredQueryStartTime","09:00");     
	options[14] = new DKNVPair("desStoredQuerySaveHitListToDataSource","[--None--]");
	options[15] = new DKNVPair("desStoredQuerySaveToDataSource","[--None--]");  
	options[16] = new DKNVPair("esSavePageSize","5");           
	options[17] = new DKNVPair("DOCWORDS","");
	options[18] = new DKNVPair("DOCTITLE","");
	options[19] = new DKNVPair("DESError","");
	options[20] = new DKNVPair("desStoredQueryFreqType","Minutes");

	/** params to be ignored **/
        options[21] = new DKNVPair("METHOD","JUNK");
        options[22] = new DKNVPair("ServerName","JUNK");
        options[23] = new DKNVPair("ServerPort","JUNK");
        options[24] = new DKNVPair("ServPath","JUNK");
        options[25] = new DKNVPair("ReqURI","JUNK");
        options[26] = new DKNVPair("esJSPError","JUNK");
        options[27] = new DKNVPair("esJSPResults","JUNK");
        options[28] = new DKNVPair("esJSPSearchPage","JUNK");
        options[29] = new DKNVPair("desSavedSearchResultsTemplate","JUNK");
        options[30] = new DKNVPair("desJSPFile","JUNK");
        options[31] = new DKNVPair("desSavedSearchTemplate","JUNK");
        options[32] = new DKNVPair("desSearchTemplate","JUNK");
	/*** end of list **/

        
	dsDES.addStoredQueryAndSchedule(cmd,options);

	/*
	DKNVPair opts[] = null;
	opts = dsDES.getStoredQueryOptions("FinalList", "Test1");
	if(opts == null){
		System.out.println("Sorry No reqParms found !!Error!!");
	}
	else{
		System.out.println("reqParms size="+opts.length);
		//list all values
		for(int i=0; i< opts.length; ++i){
			String name, value;
			String[] arrValue;
			name = opts[i].getName();
			if(name != "DESDataSourceNames" &&
				name != "DESCategoryNames"){
				value = (String) opts[i].getValue();
				System.out.println("Name=" +name+" value="+value);
			}
			else{
				arrValue = (String[])opts[i].getValue();
				System.out.println("arrValue size="+arrValue.length);
				for(int j=0;j<arrValue.length; ++j){
					System.out.println("Name=" +name+" arrValue["+j+"]="+arrValue[j]);
				}
			}

		
		}
	}
	*/

    dsDES.disconnect();
    System.out.println("datastore disconnected");
    userName = dsDES.userName();
    dsName = dsDES.datastoreName();
    System.out.println("user " + userName + " dsName " + dsName);
    dsDES.destroy();
    }
    catch (DKException exc)
    {
     try {
     dsDES.destroy();
     }
     catch (Exception e)
     {
      e.printStackTrace();
     }
     System.out.println("Exception name " + exc.name());
     System.out.println("Exception message " + exc.getMessage());
     exc.printStackTrace();
    }
    catch (Exception exc)
    {
     try {
     dsDES.destroy();
     }
     catch (Exception e)
     {
      e.printStackTrace();
     }
     System.out.println("Exception message " + exc.getMessage());
     exc.printStackTrace();
    }

  }
}

