/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Enterprise Information Portal for Multiplatforms V8.1 (program number 5724-B43)*
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                         *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************/

/* -------------------------------------------------------------------------
 * Class Name  : TMemUsage.java
 * Description : gets Java memory usage and VirtualMemory size for the 
 *               current process on NT.
 *               
 *               This program can be used independently (through DLL from 
 *               C or through java/JNI from TMemUsage.java)
 *
 *               This program uses TMemUsage.c by loading TMemUsage.dll
 *
 * Author      : Chandra S Potula
 * Create Date : 10/15/2000
 * 
 * Change History
 * -------------------------------------------------------------------------
 */

import java.text.DecimalFormat;

public class TMemUsage {
	private static DecimalFormat _dFormat;

	static {
		System.loadLibrary("TMemUsage");  
		_dFormat = new DecimalFormat("00.00");
	}


	// Right now this method works for NT only.
	public static native long getVMSize();

public static final String getMemUsage() {
	Runtime lRuntime = Runtime.getRuntime();
	long    lFree    = lRuntime.freeMemory();
	long    lTotal   = lRuntime.totalMemory();
	double  lUsed    = (double) (100 * ((float)lFree / lTotal) + 0.005);
	String  strPCent = _dFormat.format(lUsed);

	// make sure that lFree, lTotal are of same length
	String  strFree  = ("        " + lFree );
	String  strTotal = ("        " + lTotal);
	strFree  = strFree .substring(strFree .length() - 8);
	strTotal = strTotal.substring(strTotal.length() - 8);

	return("MemUsage:" +  strPCent + "% Free (" + strFree + "/" + strTotal + 
			")  VMSize:" + (getVMSize() / 1024) + "K");
}
}

