/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Enterprise Information Portal for Multiplatforms V8.1 (program number 5724-B43)*
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                         *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************/
/**************************************************************************************
 * txdoretxsDL.java - test the xdo retrieve/open and using the extension object.
 * (this test case requires you to know the existing itemId and partId in the library.)
 **************************************************************************************/
import com.ibm.mm.sdk.server.*;
import com.ibm.mm.sdk.common.*;
import java.io.*;
import java.lang.*;

public class txdoretxsDL implements DKConstantDL
{
  //replace following with your library server name, userid, pasword
  public static final String STR_LIB_SERVER  = "LIBSRVRN";
  public static final String STR_USER_ID     = "FRNADMIN";
  public static final String STR_PASSWORD    = "PASSWORD";

  // Main method
  public static void main(String args[])
  {
    // Indicate this is a Console Application on Windows NT/95 for error
    // message display in dos console code page. If this was a Windows
    // GUI (Graphic User Interface) Application this would not be necessary
    // because DK_CM_SS_WINDOWS is the default.
    DKEnvironment.setSubSystem(DK_CM_SS_CONSOLE);

    int    partId = 2;  
    String itemId = "K5#NLPETZ#TU2D$2";
    String repType = "";
    if (args.length == 3)
    {
      partId = (short)Integer.parseInt(args[0], 10);
      repType = args[1];
      itemId = args[2];
      System.out.println("You enter: java txdoretxsDL " +
       + partId + " " + repType + " " + itemId);
    }
    if (args.length == 2)
    {
      partId = (short)Integer.parseInt(args[0], 10);
      repType = args[1];
      System.out.println("You enter: java txdoretxsDL " +
       + partId + " " + repType);
    }
    if (args.length == 1)
    {
      partId =(short)Integer.parseInt(args[0], 10);
      System.out.println("You enter: java txdoretxsDL " + partId );
      System.out.println("The supplied default repType = " + repType);
      System.out.println("The supplied default itemId = " + itemId);
    }
    if (args.length == 0)
    {
      System.out.println("invoke: java txdoretxsDL <partId> <repType> <itemId>");
      System.out.println("No parameter, folldeowing defaults will be provided:");
      System.out.println("     default partId = " + partId);
      System.out.println("     default repType = " + repType);
      System.out.println("     default itemId = " + itemId);
    } 
    
    DKDatastoreDL dsDL = null;
    try 
    {
      dsDL = new DKDatastoreDL();
      System.out.println("connecting to datastore..."); 
      dsDL.connect(STR_LIB_SERVER, STR_USER_ID, STR_PASSWORD, "");
      System.out.println("datastore connected"); 
     
      DKBlobDL axdo = new DKBlobDL(dsDL);
      DKPidXDODL  apid = new DKPidXDODL();
      apid.setPartId(partId);
      apid.setItemId(itemId);
      apid.setRepType(repType);
      axdo.setPidObject(apid);
      System.out.println("repType=" + apid.getRepType()); 
      System.out.println("objectType=" + axdo.getObjectType());
      System.out.println("itemid=" + apid.getItemId());
      System.out.println("partId=" + apid.getPartId());

      boolean flag = axdo.isCategoryOf(DK_DL_INDEXED_OBJECT);
      boolean flag2 = axdo.isCategoryOf(DK_DL_MEDIA_OBJECT);
      System.out.println("isIndexedObject?=" + flag);
      System.out.println("isMediaObject?=" + flag2);
      if (flag)
      {
       DKSearchEngineInfoDL srch = (DKSearchEngineInfoDL)axdo.getExtension("DKSearchEngineInfoDL");
       System.out.println("  serverName=" + srch.getServerName()); 
       System.out.println("  textIndex=" + srch.getTextIndex());
       System.out.println("  timeStamp=" + srch.getSearchTimestamp());
       System.out.println("  searchIndex=" + srch.getSearchIndex());  
       System.out.println("  indexedState=" + axdo.retrieveObjectState(DK_INDEXED_OBJECT)); 
      }
      if (flag2)
      {
       DKMediaStreamInfoDL media = (DKMediaStreamInfoDL)axdo.getExtension("DKMediaStreamInfoDL");
       System.out.println(" mediaformat=" + media.getMediaFormat());
       System.out.println(" mediaBitRate=" + media.getMediaBitRate());
       System.out.println(" mediastate(dynamic)=" + axdo.retrieveObjectState(DK_MEDIA_OBJECT));    
      }

      System.out.println("before retrieve......");
      System.out.println(" lob length=" + axdo.length());
      System.out.println(" size=" + axdo.getSize());
      System.out.println(" createdTimestamp=" + axdo.getCreatedTimestamp());
      System.out.println(" updatedTimestamp=" + axdo.getUpdatedTimestamp());
    
      System.out.println("about to call retrieve()");
      axdo.retrieve();
      System.out.println("after retrieve......");
      System.out.println(" lob length=" + axdo.length());
      System.out.println(" size=" + axdo.getSize());
      System.out.println(" mimeType=" + axdo.getMimeType());
      System.out.println(" createdTimestamp=" + axdo.getCreatedTimestamp());
      System.out.println(" updatedTimestamp=" + axdo.getUpdatedTimestamp());
      System.out.println("affiliatedTyp=" + axdo.getAffiliatedType());
      if (axdo.getAffiliatedType() == DK_DL_ANNOTATION)
      {
       DKAnnotationDL ann = (DKAnnotationDL)(axdo.getExtension("DKAnnotationDL"));
       System.out.println("affil pageNumber=" + ann.getPageNumber());
       System.out.println("affil X=" + ann.getX());
       System.out.println("affil Y=" + ann.getY());
      }
      System.out.println("about to do open()...");
      axdo.setInstanceOpenHandler("notepad", true);        //default use notepad in NT
      int cc = axdo.getContentClass();
      if ( cc == DK_DL_CC_GIF)
       axdo.setInstanceOpenHandler("lviewpro ", true);     //use lviewpro in NT
      else if (cc == DK_DL_CC_AVI)
       axdo.setInstanceOpenHandler("mplay32 ", true);      //use mplay32 in NT
      else if (cc == DK_DL_CC_IBMVSS)
       axdo.setInstanceOpenHandler("iscoview ", true);     //use iscoview in NT
      axdo.open();

      dsDL.disconnect();
      System.out.println("datastore disconnected"); 
      dsDL.destroy();
    }
    catch (DKException exc)
    {
     try {
         dsDL.destroy();
     }
     catch (Exception e)
     {
      e.printStackTrace();
     }      
     System.out.println("Exception name " + exc.name());
     System.out.println("Exception message " + exc.getMessage());
     exc.printStackTrace();
    }
    catch (Exception exc)
    {
     try {
         dsDL.destroy();
     }
     catch (Exception e)
     {
      e.printStackTrace();
     }      
     System.out.println("Exception name " );
     System.out.println("Exception message " + exc.getMessage());
     exc.printStackTrace();
    }
  }
}

