/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Enterprise Information Portal for Multiplatforms V8.1 (program number 5724-B43)*
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                         *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************/

/*
 * Filename       : TDatastorePoolFed.java
 * Description    : test DKDatastorePool for datastore connection pool
 *
 */

import com.ibm.mm.sdk.common.*;
import com.ibm.mm.sdk.cs.*;
import java.io.*;
import java.lang.reflect.*;

// TDatastorePoolFed class
public class TDatastorePoolFed implements DKConstantFed {

  public static String Me = new String("TListSubEntitiesFed");
  // Main method
  public static void main(String argv[]){
    
      //*** for input parameters
      String libSrv = new String("");   // libserver
      String userid = new String("");   // userid
      String pw     = new String("");   // pw
      String connect_string     = new String("");  // DBAUTH
      String fullClassName = "com.ibm.mm.sdk.server.DKDatastoreFed";

   // Indicate this is a Console Application on Windows NT/95 for error
   // message display in dos console code page. If this was a Windows
   // GUI (Graphic User Interface) Application this would not be necessary
   // because DK_CM_SS_WINDOWS is the default.
   DKEnvironment.setSubSystem(DK_CM_SS_CONSOLE);

      //-------------------------------------------------------------- 
      // Checking for input parameters
      //-------------------------------------------------------------- 
     
      if (argv.length < 3)
      {
       System.out.println("Usage: " );
       System.out.println("  java TDatastorePoolFed " +
        "<db> <userid> <pw> <connect string>" );
       return;
      }
      else
      {
       libSrv = argv[0];
       userid = argv[1];
       pw = argv[2];
       if (argv.length > 3)
          connect_string = argv[3];
      } 
    try {
    DKDatastorePool dsrFed = new DKDatastorePool(fullClassName);
    dsrFed.setDatastoreName(libSrv);
    dsrFed.setMaxPoolSize(10);
    dsrFed.setMinPoolSize(3);
    if (!connect_string.equals(""))
      dsrFed.setConnectString(connect_string);
    else
      dsrFed.setConnectString("DBAUTH=SERVER"); //default connectString

    dsrFed.initConnections(userid, pw, 2);
    dsrFed.setTimeOut(1); 
    System.out.println(" getMaxPoolSize =  " + dsrFed.getMaxPoolSize());
    System.out.println(" getMinPoolSize =  " + dsrFed.getMinPoolSize());
    System.out.println(" getTimeOut=  " + dsrFed.getTimeOut());

    dkDatastore dsFed1, dsFed2, dsFed3, dsFed4;
    dsFed1 = dsrFed.getConnection(userid, pw);             // new ds1
    System.out.println(" getConnection, dsFed1(ds1) =  " + dsFed1);
    dsFed2 = dsrFed.getConnection(userid, pw);             // new ds2
    System.out.println(" getConnection, dsFed2(ds2) =  " + dsFed2);

    DKDatastoreSession dsIdFed1, dsIdFed2, dsIdFed3, dsIdFed4;
    dsIdFed1 = dsrFed.getConnection(userid, pw, 0);        //new dsid1
    System.out.println(" getConnection, dsIdFed1(dsid1)=" +
     dsIdFed1.getDatastore() + ", sessionId=" + dsIdFed1.getId());
    dsIdFed2 = dsrFed.getConnection(userid, pw, 0);        //new dsid2
    System.out.println(" getConnection, dsIdFed2(dsid2)=" +
     dsIdFed2.getDatastore() + ", sessionId=" + dsIdFed2.getId()); 

    dsrFed.returnConnection(dsIdFed2);                     //dsid2 in _freeIdPool
    System.out.println(" returnConnection, dsIdFed2(dsid2) =  " + 
      dsIdFed2.getDatastore() + ", sessionId=" + dsIdFed2.getId());
    dsrFed.returnConnection(dsFed2);                       //ds2 in _freePool
    System.out.println(" returnConnection, dsFed2(ds2) =  " + dsFed2); 

    dsIdFed3 = dsrFed.getConnection(userid, pw, 1); //ds2 in _usedPool
    System.out.println(" getConnection, dsIdFed3(ds2)=" +
     dsIdFed3.getDatastore() + ", sessionId=" + dsIdFed3.getId());
    dsIdFed4 = dsrFed.getConnection(userid, pw, 5); //new dsid3  
    System.out.println(" getConnection, dsIdFed4(dsid3)=" +
     dsIdFed4.getDatastore() + ", sessionId=" + dsIdFed4.getId());


    dsIdFed4 = dsrFed.getConnection(userid, pw, 6); // new dsid4
    System.out.println(" getConnection, dsIdFed4(dsid4)=" +
     dsIdFed4.getDatastore() + ", sessionId=" + dsIdFed4.getId());

    dsFed1 = dsrFed.getConnection(userid, pw);  // new ds3
    System.out.println(" getConnection, dsFed1(ds3) =  " + dsFed1);
    dsFed2 = dsrFed.getConnection(userid, pw);  // new ds4
    System.out.println(" getConnection, dsFed2(ds4) =  " + dsFed2); 

    dsFed3 = dsrFed.getConnection(userid, pw);  // new ds5
    System.out.println(" getConnection, dsFed3(ds5) =  " + dsFed3);
    dsFed4 = dsrFed.getConnection(userid, pw);  // new ds6
    System.out.println(" getConnection, dsFed4(ds6) =  " + dsFed4); 


    dsIdFed3 = dsrFed.getConnection(userid, pw, 9); // dsid2 
    System.out.println(" getConnection, dsIdFed3(dsid2)=" +
     dsIdFed3.getDatastore() + ", sessionId=" + dsIdFed3.getId());


    //**** use dsFed2 to do ListCatalog
    System.out.println("||**** start: use dsFed2 to do ListCatalog ****||");
    	 DKSequentialCollection pCol = null;
    	 dkIterator pIter = null;
    	 DKServerDefFed pSV = null;
    	 String strServerName = "";
    	 String strRepType = "";
         int i = 0;
    	 System.out.println("list servers");
    	 pCol = (DKSequentialCollection)dsFed2.listDataSources();
    	 pIter = pCol.createIterator();
    	 while (pIter.more() == true)
    	 {
    	  i++;
    	  pSV = (DKServerDefFed)pIter.next();
    	  strServerName = pSV.getName();
    	  strRepType = pSV.getRepositoryType();
    	  System.out.println("Server Name [" + i + "] - " + strServerName + " Server Repository Type - " + strRepType);
    	 }
    	 System.out.println(i + " servers listed");
         String userName = dsFed2.userName();
         String dsName = dsFed2.datastoreName();
         System.out.println("     user " + userName + " dsName " + dsName); 

         // get the Def and Admin
         dkDatastoreDef  defFed = dsFed2.datastoreDef();
         DKDatastoreAdminFed    adm = (DKDatastoreAdminFed) defFed.datastoreAdmin();

         //=======================================================================================================
         // list back-end servers

         String servers[] = adm.listServerNames();
         System.out.println("List of servers in federated database");
         for (int index = 0; index < servers.length; index++)
            System.out.println("Server [" + index + "] = " + servers[index].trim());
      
         System.out.println("\nDetail servers description");
         // retrieve the definition of the servers
         DKServerMapDefFed serverdat;
         for (int index = 0; index < servers.length; index ++) {
            serverdat = adm.getServer(servers[index]);
            System.out.println("\n DKServerMapDefFed = " + serverdat.getName().trim());
            System.out.println("          name: " + serverdat.getName().trim());
            System.out.println("          type: " + serverdat.getServerType());
            System.out.println("   Connect Str: " + serverdat.getConnectString());
            System.out.println("         desc : " + serverdat.getDescription());
            System.out.println("      refTime : " + serverdat.getRefreshTime());
         }
	
         //=======================================================================================================
         // list federated entity and attribute names

	     String[] names = dsFed2.listEntityNames();
	     for (i=0; i<names.length; i++) {
		    System.out.println("name[" + i + "] = " + names[i] );
		    dkEntityDef entityFed   = defFed.getEntity(names[i]);
		    System.out.println("\tDescription= " + entityFed.getDescription());

		    String[] attrNames   = entityFed.listAttrNames();
		    if (attrNames != null) {
			    for (int j=0; j<attrNames.length; j++) {	
				    System.out.println("\tattrName = " + attrNames[j]);
				    dkAttrDef attr = entityFed.getAttr(attrNames[j]);
				    System.out.println("\t\tentityName:   " + attr.getEntityName());
				    System.out.println("\t\tdsName:       " + attr.datastoreName());
				    System.out.println("\t\tdsType:       " + attr.datastoreType());
				    System.out.println("\t\ttype:         " + attr.getType());
				    System.out.println("\t\tdescription:  " + attr.getDescription());
				    System.out.println("\t\tsize:         " + attr.getSize());
				    System.out.println("\t\tid:           " + attr.getId());
				    System.out.println("\t\tprecision:    " + attr.getPrecision());
				    System.out.println("\t\tscale:        " + attr.getScale());
				    System.out.println("\t\tmax:          " + attr.getMax());
				    System.out.println("\t\tmin:          " + attr.getMin());
				    System.out.println("\t\tstringType:   " + attr.getStringType());

				    if (attr.isNullable())
					    System.out.println("\t\tisNullable:   true");
				    else 
					    System.out.println("\t\tisNullable:   false");
	
				    if (attr.isUpdatable())
					    System.out.println("\t\tisUpdatable:  true");
				    else 
					    System.out.println("\t\tisUpdatable:  false");
			
				    if (attr.isQueryable())
					    System.out.println("\t\tisQueryable:  true");
				    else 
					    System.out.println("\t\tisQueryable:  false");
				    System.out.println("\n");
			    }
		    }
	    }

    System.out.println("||**** end: use dsFed2 to do ListCatalog ****||");
    //****end of use dsFed2 to do ListCatalog

    dsrFed.returnConnection(dsFed2);
    System.out.println(" returnConnection, dsFed2(ds4) =  " + dsFed2);
    dsFed4 = dsrFed.getConnection(userid, pw);
    System.out.print(" getConnection, dsFed4 =  " + dsFed4); 
    System.out.println("    dsFed4 == dsFed2 =  " + (dsFed4 == dsFed2)); //true

    //**** you can add codes to use dsFed4 to do other thing here  
    //**** end of use dsFed4 to do other thing
       
    dsrFed.returnConnection(dsFed1);
    System.out.println(" returnConnection, dsFed1(ds3) =  " + dsFed1);
    dsrFed.returnConnection(dsFed3);
    System.out.println(" returnConnection, dsFed3(ds5) =  " + dsFed3);
    dsrFed.returnConnection(dsIdFed4); //dsid4 in _freeIdPool
    System.out.println(" returnConnection, dsIdFed4(dsid4) =  " + 
      dsIdFed4.getDatastore() + ", sessionId=" + dsIdFed4.getId());
     

    System.out.println("**** start sleep for 120050 mini sec*******");
    Thread.sleep(120050);  //the two in freePool will be disconnected
    System.out.println("**** end sleep for 120050 mini sec*******");

    dsFed2 = dsrFed.getConnection(userid, pw);     //new ds7
    System.out.println(" getConnection, dsFed2(ds7) =  " + dsFed2); 
    System.out.println(" call destroy()..." );
    dsrFed.destroy();  //take a while for all 4 in usedPool to be disconnected

    }
    catch (DKException exc)
    {
     System.out.println("Exception name " + exc.name());
     System.out.println("Exception message " + exc.getMessage());
     exc.printStackTrace();
    }
    catch (Exception exc)
    {
     System.out.println("Exception message " + exc.getMessage());
     exc.printStackTrace();
    }

  }
}

