/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Enterprise Information Portal for Multiplatforms V8.1 (program number 5724-B43)*
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                         *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************/


//import java.net.URL;
//import java.sql.*;
import java.lang.*;
import com.ibm.mm.sdk.common.dkSchemaMapping;
import com.ibm.mm.sdk.common.dkAttrMapping;
import com.ibm.mm.sdk.common.*;
import com.ibm.mm.sdk.server.*;

class TSchemaMappingUpdateFed
{
    public static void main(String argv[])
    {
        dkDatastore     _ds = null;
        dkSchemaMapping _sm;
        String          _servername;
        String          _servertype;
        String          _fentityname;
        String          _nentityname;
        String          _fattrname;
        int             _fattrtype;
        int             _fattrsize;
        int             _fattrprecision;
        int             _fattrscale;
        int             _fmax;
        int             _fmin;
        boolean         _fcontrol;
        String          _nattrname;
        int             _datatype;
        int             _length;
        int             _precision;
        int             _scale;
        int             _lowerlimit;
        int             _upperlimit;
        boolean         _control;
        String          _fromfcn;
        String          _tofcn;

        try {
            // create federated datastore
            _ds = new DKDatastoreFed();
            _ds.connect("feddb", "KIRK", "pw", "aa");
            //initial();
            _sm = null;
            _servername = null;
            _servertype = null;
            _fentityname = null;
            _nentityname = null;
            _fattrname = null;
            _fattrtype = 0;
            _fattrsize = 0;
            _fattrprecision = 0;
            _fattrscale = 0;
            _fmax = 0;
            _fmin = 0;
            _fcontrol = false;
            _nattrname = null;
            _datatype = 0;
            _length = 0;
            _precision = 0;
            _scale = 0;
            _lowerlimit = 0;
            _upperlimit = 0;
            _control = false;
            _fromfcn = null;
            _tofcn = null;

            _servername = "LIBLAHM";
            _servertype = "VI/DL";
            _fentityname = "Employee";
            _nentityname = "EmpTable";

            //createSchemaMapping();
            _sm = new DKSchemaMappingFed(_ds);
            _sm.setServerName(_servername);
            _sm.setServerType(_servertype);
            _sm.setMappedEntityName(_fentityname);
            _sm.setEntityName(_nentityname);

            //fillData();
            // mapping #1
            _fromfcn = "changeToEnglish";
            _tofcn = "changeFromEnglish";
            _fattrname = "empname";
            _fattrtype = 999;
            _fattrsize = 10;
            _fattrprecision = 3;
            _fattrscale = 4;
            _fmax = 1000;
            _fmin = 3;
            _fcontrol = true;
            _nattrname = "newfirstname";
            _datatype = 888;
            _length = 3;
            _precision = 4;
            _scale = 2;
            _lowerlimit = 1111;
            _upperlimit = 9999;
            _control = true;
            dkAttrMapping am = new DKAttrMappingFed();
            am.setFromNative(_fromfcn);
            am.setToNative(_tofcn);
            dkAttrDef adf = new DKAttrDefFed();
            adf.setName(_fattrname);
            adf.setType((short)_fattrtype);
            adf.setSize(_fattrsize);
            adf.setPrecision(_fattrprecision);
            adf.setScale(_fattrscale);
            adf.setMax(_fmax);
            adf.setMin(_fmin);
            adf.setNullable(_fcontrol);
            am.addMappedAttr(adf);
            dkAttrDef add = new DKAttrDefDL();
            add.setName(_nattrname);
            add.setType((short)_datatype);
            add.setSize(_length);
            add.setPrecision(_precision);
            add.setScale(_scale);
            add.setMin(_lowerlimit);
            add.setMax(_upperlimit);
            add.setQueryable(_control);
            am.addMapToAttr(add);
            _sm.addAttrMapping(am);
            // mapping #2
            _fromfcn = "changeToDollar";
            _tofcn = "changeFromDollar";
            _fattrname = "salary";
            _fattrtype = 999;
            _fattrsize = 10;
            _fattrprecision = 3;
            _fattrscale = 4;
            _fmax = 1000;
            _fmin = 3;
            _fcontrol = true;
            _nattrname = "newmain";
            _datatype = 888;
            _length = 3;
            _precision = 4;
            _scale = 2;
            _lowerlimit = 2222;
            _upperlimit = 8888;
            _control = true;
            dkAttrMapping am2 = new DKAttrMappingFed();
            am2.setFromNative(_fromfcn);
            am2.setToNative(_tofcn);
            dkAttrDef adf2 = new DKAttrDefFed();
            adf2.setName(_fattrname);
            adf2.setType((short)_fattrtype);
            adf2.setSize(_fattrsize);
            adf2.setPrecision(_fattrprecision);
            adf2.setScale(_fattrscale);
            adf2.setMax(_fmax);
            adf2.setMin(_fmin);
            adf2.setNullable(_fcontrol);
            am2.addMappedAttr(adf2);
            dkAttrDef add2 = new DKAttrDefDL();
            add2.setName(_nattrname);
            add2.setType((short)_datatype);
            add2.setSize(_length);
            add2.setPrecision(_precision);
            add2.setScale(_scale);
            add2.setMin(_lowerlimit);
            add2.setMax(_upperlimit);
            add2.setQueryable(_control);
            am2.addMapToAttr(add2);
            // mapping #2.1
            _nattrname = "newcommission";
            _datatype = 888;
            _length = 3;
            _precision = 4;
            _scale = 2;
            _lowerlimit = 3333;
            _upperlimit = 7777;
            _control = true;
            dkAttrDef add2s1 = new DKAttrDefDL();
            add2s1.setName(_nattrname);
            add2s1.setType((short)_datatype);
            add2s1.setSize(_length);
            add2s1.setPrecision(_precision);
            add2s1.setScale(_scale);
            add2s1.setMin(_lowerlimit);
            add2s1.setMax(_upperlimit);
            add2s1.setQueryable(_control);
            am2.addMapToAttr(add2s1);
            // mapping #2.2
            _nattrname = "newbonus";
            _datatype = 888;
            _length = 3;
            _precision = 4;
            _scale = 2;
            _lowerlimit = 3333;
            _upperlimit = 7777;
            _control = true;
            dkAttrDef add2s2 = new DKAttrDefDL();
            add2s2.setName(_nattrname);
            add2s2.setType((short)_datatype);
            add2s2.setSize(_length);
            add2s2.setPrecision(_precision);
            add2s2.setScale(_scale);
            add2s2.setMin(_lowerlimit);
            add2s2.setMax(_upperlimit);
            add2s2.setQueryable(_control);
            am2.addMapToAttr(add2s2);
            _sm.addAttrMapping(am2);
            // mapping #3
            _fromfcn = "changeToUSA";
            _tofcn = "changeFromAsia";
            _fattrname = "Address";
            _fattrtype = 999;
            _fattrsize = 10;
            _fattrprecision = 3;
            _fattrscale = 4;
            _fmax = 1000;
            _fmin = 3;
            _fcontrol = true;
            _nattrname = "newMainAddress";
            _datatype = 888;
            _length = 3;
            _precision = 4;
            _scale = 2;
            _lowerlimit = 2222;
            _upperlimit = 8888;
            _control = true;
            dkAttrMapping am3 = new DKAttrMappingFed();
            am3.setFromNative(_fromfcn);
            am3.setToNative(_tofcn);
            dkAttrDef adf3 = new DKAttrDefFed();
            adf3.setName(_fattrname);
            adf3.setType((short)_fattrtype);
            adf3.setSize(_fattrsize);
            adf3.setPrecision(_fattrprecision);
            adf3.setScale(_fattrscale);
            adf3.setMax(_fmax);
            adf3.setMin(_fmin);
            adf3.setNullable(_fcontrol);
            am3.addMappedAttr(adf3);
            dkAttrDef add3 = new DKAttrDefDL();
            add3.setName(_nattrname);
            add3.setType((short)_datatype);
            add3.setSize(_length);
            add3.setPrecision(_precision);
            add3.setScale(_scale);
            add3.setMin(_lowerlimit);
            add3.setMax(_upperlimit);
            add3.setQueryable(_control);
            am3.addMapToAttr(add3);
            // mapping #3.1
            _nattrname = "newCity";
            _datatype = 888;
            _length = 3;
            _precision = 4;
            _scale = 2;
            _lowerlimit = 3333;
            _upperlimit = 7777;
            _control = true;
            dkAttrDef add3s1 = new DKAttrDefDL();
            add3s1.setName(_nattrname);
            add3s1.setType((short)_datatype);
            add3s1.setSize(_length);
            add3s1.setPrecision(_precision);
            add3s1.setScale(_scale);
            add3s1.setMin(_lowerlimit);
            add3s1.setMax(_upperlimit);
            add3s1.setQueryable(_control);
            am3.addMapToAttr(add3s1);
            _sm.addAttrMapping(am3);

            _sm.update();
            _ds.disconnect();
            _ds.destroy();

        }
        catch (java.lang.Exception ex)
        {
            ex.printStackTrace();
        }
    }
}
