/* -------------------------------------------------------------------
 * @copyright(disclaimer) 
 * IBM Enterprise Information Portal for Multiplatforms V7.1  (program number 5697-G29) 
 * (c ) Copyright IBM Corp. 1998, 2000. All Rights Reserved. 
 * IBM Content Manager for Multiplatforms V6.1  (program number 5648-D03) 
 * (c ) Copyright IBM Corp. 1994, 2000. All Rights Reserved. 
 * 
 * US Government Users Restricted Rights 
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.  Licensed Materials - Property of IBM 
 * 
 * DISCLAIMER OF WARRANTIES : 
 * 
 * Permission is granted to copy and modify this code, and to 
 * distribute modified versions provided that both the copyright 
 * notice and this permission notice appear in all copies and modified 
 * versions. THIS SAMPLE CODE IS LICENSED TO YOU AS-IS. IBM DISCLAIMS 
 * ALL WARRANTIES, EITHER EXPRESS OR IMPLIED, IN SUCH SAMPLE CODE. IBM 
 * WILL NOT BE LIABLE FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE 
 * OF THE CODE.
 * 
 * @endCopyright
 */

/*
 * Filename       : TEntityIC.java
 * Description    : sample for entity functions
 * Change History :
 *
 *
 */

import com.ibm.mm.sdk.common.*;
import com.ibm.mm.sdk.server.*;
import java.io.*;

// TEntityIC class
public class TEntityIC implements DKConstantIC {

  // Main method
  public static void main(String argv[]){
    
      String db = new String("");   // database
      String userid = new String("");   // userid
      String pw = new String("");   // pw
      int count = 0;
      int i = 0;

   // Indicate this is a Console Application on Windows NT/95 for error
   // message display in dos console code page. If this was a Windows
   // GUI (Graphic User Interface) Application this would not be necessary
   // because DK_CM_SS_WINDOWS is the default.
   DKEnvironment.setSubSystem(DK_CM_SS_CONSOLE);

      //-------------------------------------------------------------- 
      // Checking for input parameters
      //-------------------------------------------------------------- 
      if (argv.length < 3)
      {
       System.out.println("Usage: " );
       System.out.println("  java TEntityIC " +
        "<db> <userid> <pw>" );
       return;
      }

      db = argv[0];
      userid = argv[1];
      pw = argv[2];

    try {

      
       DKDatastoreIC dsIC = new DKDatastoreIC();
       dsIC.connect(db, userid, pw, "");
       System.out.println("--- connected to datastore ---");

      
// listEntities()

      dkIterator itr = dsIC.datastoreDef().listEntities().createIterator();
      while ( itr.more() ) {
         dkEntityDef entity = (dkEntityDef)itr.next();
         count ++;
         System.out.println("Entity = " + entity.getName());
      }
      System.out.println("Number of entities = " + count);
      count = 0;

// listEntityNames()

      String entityNames[] = dsIC.datastoreDef().listEntityNames();
      int numEntities = entityNames.length;
      for ( i = 0; i < numEntities; i++) {
          count ++;
          System.out.println("Entity Name = " + entityNames[i]);
      }

      System.out.println("Number of entity names = " + count);
      count = 0;

// listEntityAttrs()

      String eName = "Images or graphics";
      itr = dsIC.datastoreDef().listEntityAttrs(eName).createIterator();
      while ( itr.more() ) {
         dkAttrDef entityAttr = (dkAttrDef)itr.next();
         count ++;
         System.out.println("Entity Attr = " + entityAttr.getName());
      }
      System.out.println("Number of entity attrs = " + count);
      count = 0;

// listEntityAttrNames()

      eName = "Charts";
      String entityAttrNames[] = dsIC.datastoreDef().listEntityAttrNames(eName);
      int numEntityAttrs = entityAttrNames.length;
      for ( i = 0; i < numEntityAttrs; i++) {
          count ++;
          System.out.println("Entity Attr Name = " + entityAttrNames[i]);
      }

      System.out.println("Number of entity names = " + count);
      count = 0;


// getEntity()

      dkEntityDef entityDef = dsIC.datastoreDef().getEntity("Internet documents");
      System.out.println("Entity = " + entityDef.getName());

      count = 0;


// datastoreType()

      String dstype = dsIC.datastoreDef().datastoreType();
      System.out.println("Data Store Type = " + dstype);

       dsIC.disconnect();
       System.out.println("datastore disconnected");
       dsIC.destroy();
    }
    catch(DKException exc)
    {
       System.out.println("Exception name " + exc.name());
       System.out.println("Exception message " + exc.getMessage());
       System.out.println("Exception error code " + exc.errorCode());
       System.out.println("Exception error state " + exc.errorState());
       exc.printStackTrace();
    }
    catch (Exception exc)
    {
     System.out.println("Exception message " + exc.getMessage());
     exc.printStackTrace();
    }
  }
}

