/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Enterprise Information Portal for Multiplatforms V8.1 (program number 5724-B43)*
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                         *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************/
                                                        
// test list servers/ list schema / list schema attributes from JDBC

/*
 * Filename       : TListCatalogJDBC.java
 * Description    : test DKDatastoreJDBC for list functions
 * Change History :
 *
 * Date        Name  Description     
 * -------    -----  ---------------------------
 *
 */

import com.ibm.mm.sdk.common.*;
import com.ibm.mm.sdk.server.*;
import java.io.*;

// TListCatalogJDBC class
public class TListCatalogJDBC implements DKConstantJDBC {

  // Main method
  public static void main(String argv[]){
    
      String url = new String("");   // url
      String userid = new String("");   // userid
      String pw = new String("");   // pw
      String schema = new String("");   // schema

   // Indicate this is a Console Application on Windows NT/95 for error
   // message display in dos console code page. If this was a Windows
   // GUI (Graphic User Interface) Application this would not be necessary
   // because DK_CM_SS_WINDOWS is the default.
   DKEnvironment.setSubSystem(DK_CM_SS_CONSOLE);

      //-------------------------------------------------------------- 
      // Checking for input parameters
      //-------------------------------------------------------------- 
      if (argv.length < 3)
      {
       System.out.println("Invoke Syntax: " );
       System.out.println("  java TListCatalogJDBC " +
        "<url> <uid> <pw> [<schema-name> - optional]");
       return;
      }
      else if (argv.length == 4)
      {
       schema = argv[3];
      }

      url = argv[0];
      userid = argv[1];
      pw = argv[2];

    DKDatastoreJDBC dsJDBC = null;
    try {
    // url = "jdbc:db2:sample";
    // url = "jdbc:odbc:sample";
    DKSequentialCollection pCol = null;
    dkIterator pIter = null;
    DKSequentialCollection pCol2 = null;
    dkIterator pIter2 = null;
    DKServerDefJDBC pSV = null;
    String strServerName = null;
    String strJDBCDriver = null;
    String strTable = null;
    DKTableDefJDBC tableDef = null;
    DKColumnDefJDBC colDef = null;
    DKDatastoreDefJDBC dsDefJDBC = null;
    int i = 0;
    int j = 0;
    String configuration = "JDBCDRIVER=(COM.ibm.db2.jdbc.app.DB2Driver)";
    //  String configuration = "JDBCDRIVER=(sun.jdbc.odbc.JdbcOdbcDriver)";
    dsJDBC = new DKDatastoreJDBC(configuration);
    System.out.println("list servers");
    pCol = (DKSequentialCollection)dsJDBC.listDataSources();
    pIter = pCol.createIterator();
    while (pIter.more() == true)
    {
     i++;
     pSV = (DKServerDefJDBC)pIter.next();
     strServerName = pSV.getName();
     strJDBCDriver = pSV.getJDBCDriver();
     System.out.println("Server Name [" + i + "] - " + strServerName + " JDBC Driver: " + strJDBCDriver);
    }
    System.out.println(i + " servers listed");
    System.out.println("connecting to datastore"); 
    dsJDBC.connect(url,userid,pw,"");
    System.out.println("datastore connected url " + url + " userid " +
                        userid ); 
    if (!schema.equals(""))
    {
     dsDefJDBC = (DKDatastoreDefJDBC)dsJDBC.datastoreDef();
     dsDefJDBC.setSchemaName(schema);
     schema = dsDefJDBC.getSchemaName();
     System.out.println(" New Schema Name = [" + schema + "]");
    }
    System.out.println("list tables");
    pCol = (DKSequentialCollection) dsJDBC.listEntities();
    pIter = pCol.createIterator();
    i = 0;
    while (pIter.more() == true)
    {
     i++;
     tableDef = (DKTableDefJDBC)pIter.next();
     strTable = tableDef.getName();
     System.out.println("table name [" + i + "] - " + strTable);
     System.out.println("  list columns for " + strTable + " table");
     pCol2 = (DKSequentialCollection) dsJDBC.listEntityAttrs(strTable);
     pIter2 = pCol2.createIterator();
     j = 0;
     while (pIter2.more() == true)
     {
      j++;
      colDef = (DKColumnDefJDBC)pIter2.next();
      System.out.println("    Attribute name [" + j + "] - " + colDef.getName());
      System.out.println("      datastoreType " + colDef.datastoreType());
      System.out.println("      attributeOf " + colDef.getEntityName());
      System.out.println("      type " + colDef.getType());
      System.out.println("      size " + colDef.getSize());
      System.out.println("      id " + colDef.getId());
      System.out.println("      nullable " + colDef.isNullable());
      System.out.println("      precision " + colDef.getPrecision());
      System.out.println("      scale " + colDef.getScale());
      System.out.println("      stringType " + colDef.getStringType());
      System.out.println("      primary key " + colDef.isPrimaryKey());
      System.out.println("      foreign key " + colDef.isForeignKey());
     }
     System.out.println("  " + j + " columns listed for " + strTable + " table");
    }
    System.out.println(i + " tables listed");
    dsJDBC.commit();
    dsJDBC.disconnect();
    System.out.println("datastore disconnected"); 
    dsJDBC.destroy();
    }
    catch(DKException exc)
    {
     try {
     dsJDBC.destroy();
     }
     catch (Exception e)
     {
      e.printStackTrace();
     }
     System.out.println("Exception name " + exc.name());
     System.out.println("Exception message " + exc.getMessage());
     exc.printStackTrace();
    }
    catch (Exception exc)
    {
     try {
     dsJDBC.destroy();
     }
     catch (Exception e)
     {
      e.printStackTrace();
     }
     System.out.println("Exception message " + exc.getMessage());
     exc.printStackTrace();
    }
  }
}

